#include <iostream>
#include <stdlib.h>
using namespace std;

int calculate( int op1, int op2, int (*func)( int, int ) ) {
   return func( op1, op2 );
}

// сложение, вычетание, умножение, деление, остаток, возведение в степень:
int summ( int op1, int op2 ) { return op1 + op2; }
int diff( int op1, int op2 ) { return op1 - op2; }
int mult( int op1, int op2 ) { return op1 * op2; }
int divd( int op1, int op2 ) { return op1 / op2; }
int bals( int op1, int op2 ) { return op1 % op2; }
int powr( int op1, int op2 ) { 
   int ret = 1;
   while( op2-- ) ret *= op1;
   return ret; 
}

typedef int (*fint_t)( int, int );       // функции 6-ти арифметических операций
fint_t foper[] = {
   summ, diff, mult, divd, bals, powr
};

int main( int argc, char **argv, char **envp ) {
   char coper[] = { '+', '-', '*', '/', '%', '^' };
   int noper = sizeof( coper ) / sizeof( coper[ 0 ] );
   do {
      char buf[ 120 ], *endptr, *str = buf, oper;
      cout << "выражение для вычисления (<op1><знак><op2>): " << flush;
      cin >> buf;
      int op1, op2;
      op1 = strtod( str, &endptr );
      oper = *endptr++;
      op2 = strtod( str = endptr, &endptr );
      int i;
      for( i = 0; i < noper; i++ ) {
         if( oper == coper[ i ] ) {
            cout << op1 << ' ' << oper << ' ' << op2 << " = " 
                 << calculate( op1, op2, foper[ i ] ) << endl;
            break;
         }
      }
      if( i == noper )
         cout << "неверный знак операции: " << oper << endl;
   } while( true );
   return 0; 
}
